//CHAPTER 4, SOLUTION 4

public class Dates
{
  public static void main(String args[])
  {
    String[] days = new String[10];
    String[] monthNames = {
			"January", "February", "March", "April",
			"May", "June", "July", "August", "September",
			"October", "November", "December"
			};
	  
    int[] daysInMonth = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
    String ending = "th";
    String dayStr;
    String monthStr;
    String yearStr;
    char separator = '/';
    int day,month,year,start,end, daysIncrement;

    // Generate a set of arbitrary dates:
    for(int i=0 ; i<days.length ; i++)
    {
      year = (int)(100.0*Math.random());       // Random year value 00 to 99
      month = (int)(12.0*Math.random()) + 1;   // Random month value 1 to 12
      
      // February in a leap year has 29 days in the month.
      daysIncrement = (year % 4 == 0) && (month == 2) ? 1 : 0 ;
 
	    day = (int)(Math.random()*(daysInMonth[month-1]+daysIncrement))+1;

      days[i] = "" + day + separator + month + separator + (year<10 ? "0" :"") + year;
      System.out.println("Day is " + days[i]);
    }

    // Now the set has been generated, it can be interpreted and output formatted.
    System.out.println();
    for(int i = 0 ; i<days.length ; i++)
    {
      // Extract the day, month and year strings using the familiar method.
      start = 0;
      end = days[i].indexOf(separator,start);
      dayStr = days[i].substring(start, end);
      start = end+1;
      end = days[i].indexOf(separator,start);
      monthStr = days[i].substring(start, end);
      start = end+1;
      yearStr = days[i].substring(start);

      // Figure out whether "st", "nd", "rd", or "th", should be appended to the day.
      //  Single digit day is "st", "rd", "nd", for "1", "2", "3", and "th" otherwise.
      // Days "11" to "19" are all "th".
      // The remainder are "st", "rd", "nd", for last digit "1", "2", "3",
      // and "th" otherwise.
      if(dayStr.length() == 1)
        switch(dayStr.charAt(0))
        {
          case '1':
            ending = "st";
            break;
          case '2':
            ending = "nd";
            break;
          case '3':
            ending = "rd";
            break;
          default:
            ending = "th";
        }
      else if(dayStr.charAt(0) == '1')
        ending = "th";
      else 
        switch(dayStr.charAt(1))
        {
          case '1':
            ending = "st";
            break;
          case '2':
            ending = "nd";
            break;
          case '3':
            ending = "rd";
            break;
          default:
            ending = "th";
        }
          
      // We can now output the dat in the required format.
      // To output the month name string we must use monthStr to get an index to the monthNames array.  
      System.out.println(dayStr + ending + " " + 
           monthNames[monthStr.length() == 1 ? monthStr.charAt(0) - '1': 9 + monthStr.charAt(1) - '0'] +
           " " + "19" + yearStr);
    
      // The preceding would be easier using Integer class methods to convert
      // the day and month strings to integers. 
      // Number classes (Integer, Double etc.) are covered in chapter 5, p. 199.
    }
  }
}

