//CHAPTER 4, SOLUTION 3

// This solution scans the string character by character to extract words.
// We cannot conveniently use the indexOf() method because a word can end with a space
// or a punctuation character such as a period or a comma. For simplicity, we assume a 
// single quote is always part of a word.
public class Sort
{
  public static void main(String args[])
  {
    // Declare the String that is to be sorted:
    String text = "In the beginning was the Word, and the Word was " +
                  "with God and the Word was God. He was with God in " +
                  "the beginning. Through him all things were made; " +
                  "without him nothing was made that has been made. " +
                  "In him was life, and that life was the light of men. " +
                  "The light shines in the darkness, but the darkness " +
                  "has not understood it.";


    // Determine how many words there are:
    int count = 0;	                     // Counts number of words
    boolean isWord = false;              // Indicates start of a word found
    int i = 0;                           // Character position in the text string
    do
    {
      if(isWord)                         // If we have found a word...
      {
        if(Character.isLetter(text.charAt(i)) || text.charAt(i) == '\'')
          continue;                      // ...pass over letters or single quote
        else                             // It is not a letter or single quote...                            
          isWord = false;                // so we have come to the end of the word
      }
      else if(Character.isLetter(text.charAt(i)))
      {                                  // We have the first letter of a new word
          count++;                       // so increment word count
          isWord = true;                 // and record we have found a word
      }
    }while(++i<text.length());
      
        
        
    // Create the array of strings to contain all the words:
    String[] words = new String[count];

    // Now extract the words from the text
    int start = 0;                                       // Position of first letter of a word
    int wordIndex = 0;                                   // Current vacant words array element                                   
    i = 0;                                               // Position in the text
    isWord = false;                                      // Indicates when a word start is found
    do
    {
      if(!isWord)                                        // If we are not in a word...
      {                       
        if(Character.isLetter(text.charAt(i)))           // look for first letter of a word.
        {
          start = i;                                     // Record word start index
          isWord = true;                                 // We have a word
        }
      }
      else
      { // We are in a word 
        if(Character.isLetter(text.charAt(i)) || text.charAt(i) == '\'')
          continue;                                      // Still the same word so continue
        else
        {                                                // It is the end of the word
          isWord = false;                                // so reset word indicator
          words[wordIndex++] = text.substring(start,i);  // and extract the word
        }
      }          
    }while(++i<text.length());

    // If the text ends with a letter, we will not have stored the last word
    if(wordIndex < words.length)
      words[wordIndex] = text.substring(start);

    // Sort the array of words
    String current = null;               // Reference to current word

    for(int j = 1 ; j<count ; j++)	     // Look at every word, starting at 2nd.
    {
	    current = words[j];		             // Save the current word reference.
	    i = j - 1;		                     // Start comparing with the previous word.
	    while((i >= 0) && (words[i].compareTo(current) > 0))
	    {			                             // If the ith word is greater than the current,
	      words[i+1] = words[i];           // move it to the next position.
	      i--;			                       // Decrease i so the previous word is
	    }			                             // compared to current next time round.
	    words[i+1] = current;		           // Store current in last position moved
    }				                             // which will be the same position if none moved.

    // Display the sorted array of words:
    for(int j = 0 ; j<words.length ; j++)
      System.out.println(words[j]);
  }
}

