//CHAPTER 5, EXERCISE 4
package Measures;

public class tkgWeight
{
  public static final int KG_PER_TON = 1000;
  public static final int GRAMS_PER_KG = 1000;
  public static final int GRAMS_PER_TON = GRAMS_PER_KG*KG_PER_TON;

  // private member variables
  private int tons = 0;
  private int kilograms = 0;
  private int grams = 0;

  // Constructors:

  public tkgWeight(double kg)
  {    
    // Find the number of tons:
    tons = (int)(kg/KG_PER_TON); 
    
    // Find the integer number of kg:
    kilograms = (int)(kg - tons*KG_PER_TON);
    
    // Round to the nearest number of g left:
    grams = (int)Math.round((kg - tons*KG_PER_TON - kilograms)*GRAMS_PER_KG);
  }

  public tkgWeight(long g)
  {
    tons = (int)(g/GRAMS_PER_TON);    
    kilograms = (int)((g - tons*GRAMS_PER_TON)/GRAMS_PER_KG);
    grams = (int)(g - tons*GRAMS_PER_TON - kilograms*GRAMS_PER_KG);
  }

  public tkgWeight(int t, int kg, int g)
  {
    this(((long)(t))*GRAMS_PER_TON + kg*GRAMS_PER_KG + g);
  }

  public tkgWeight(){}

  // Methods
  public String toString()  // Replaces the default toString method in Object.
  {
    return Integer.toString(tons) + "t " + kilograms + "kg " + grams + "g";
  }

  public long toGrams()
  {
    return ((long)(tons))*GRAMS_PER_TON + kilograms*GRAMS_PER_KG + grams;
  }

  public double toKilograms()
  {
    return ((double)(tons))*GRAMS_PER_TON + kilograms + ((double)(grams))/GRAMS_PER_KG;
  }

  public tkgWeight add(tkgWeight weight)
  {
    return new tkgWeight(toGrams() + weight.toGrams());
  }

  public tkgWeight subtract(tkgWeight weight)
  {
    return new tkgWeight(toGrams() - weight.toGrams());
  }

  public tkgWeight multiply(int n)
  {
    return new tkgWeight(n*toGrams());
  }

  public tkgWeight divide(int n)
  {
    return new tkgWeight(Math.round(((double)toGrams())/n));
  }

  public long compare(tkgWeight weight)
  {
    return toGrams()>weight.toGrams() ? 1 : (toGrams() == weight.toGrams() ? 0 : -1);
  }
}
