package TryGeometry;

public class Point
{
  // Coordinates of the point
  private double x;
  private double y;

  // Create a point from coordinates
  public Point(double xVal, double yVal)
  {
    x = xVal;
    y = yVal;
  }

  // Create a point from another Point object
  public Point(Point point)
  {
    x = point.x;    // Copy x coordinate
    y = point.y;    // Copy y coordinate
  }

  // Move a point
  void move(double xDelta, double yDelta)
  {
    // Parameter values are increments to the current coordinates
    x += xDelta;
    y += yDelta;
  }

  // Calculate the distance to another point
  double distance(Point aPoint)
  {
    return Math.sqrt(
    (x - aPoint.x)*(x - aPoint.x) + (y - aPoint.y)*(y - aPoint.y) );
  }

  // Return the x position
  public double getX()
  {
    return x;
  }
  // Return the y position
  public double getY()
  {
    return y;
  }

  public String toString()
  {
    return "Point("+ x+ " , " + y + ")";
  }
}

