//CHAPTER 5, SOLUTION 2

public class mcmLength 
{

  public static final int CM_PER_M = 100;
  public static final int MM_PER_CM = 10;
  public static final int MM_PER_M = MM_PER_CM*CM_PER_M;

  // Private member variables:
  private int meters = 0;
  private int centimeters = 0;
  private int millimeters = 0;

  // Constructors:
  public mcmLength(double cm)
  {
    // Find the integer number of meters
    meters = ((int)(cm))/CM_PER_M;
    
    //Find the integer number of centimeters
    centimeters = (int)(cm) - CM_PER_M*meters;
    
    // The remaining millimeters is given to the nearest mm
    millimeters = (int)(Math.round(cm*MM_PER_CM) - meters*MM_PER_M - centimeters*MM_PER_CM);
  }

  public mcmLength(long mm)
  {

    meters = (int)(mm/MM_PER_M);
    centimeters = (int)((mm - meters*MM_PER_M)/MM_PER_CM);
    millimeters = (int)(mm - meters*MM_PER_M - centimeters*MM_PER_CM);
  }

  public mcmLength(int m, int cm, int mm)
  {
    this(((long)(m))*MM_PER_M + cm*MM_PER_CM + mm);
  }

  public mcmLength(){}

  // Methods
  public String toString()  // Replaces the default toString method in Object:
  {
    return Integer.toString(meters) + "m " + centimeters + "cm " + millimeters + "mm";
 
  }

  public long toMM()
  {
    return meters*MM_PER_M + centimeters*MM_PER_CM + millimeters;
  }


  public double toMeters()
  {
    return meters + ((double)(centimeters))/CM_PER_M + ((double)(millimeters))/MM_PER_M;
  }

  // All of the following methods use the toMM():
  public mcmLength add(mcmLength length)
  {
    return new mcmLength(toMM()+length.toMM());
  }

  public mcmLength subtract(mcmLength length)
  {
    return new mcmLength(toMM()-length.toMM());
  }

  public mcmLength multiply(int n)
  {
    return new mcmLength(n*toMM());
  }

  public mcmLength divide(int y)
  {
    return new mcmLength(Math.round(((double)(toMM()))/y));
  }

  public long area(mcmLength length)	//Returns area in square mm:
  {
    return (toMM()*length.toMM());
  }

  public int compare(mcmLength length)
  {
    return toMM() > length.toMM() ? 1 : (toMM() == length.toMM() ? 0 : -1);
  }

  public static void main(String args[])
  {
    mcmLength[] lengths = new mcmLength[4];

    // Test the constructors:
    lengths[0] = new mcmLength(274.65);
    lengths[1] = new mcmLength(274);
    lengths[2] = new mcmLength(274,2,3);
    lengths[3] = new mcmLength();

    //Display the figures:
    for(int i=0;i<lengths.length;i++)
      System.out.println("Length " + i + " is " + lengths[i]);

    // Test the operations:
    System.out.println("Addition: " + lengths[0] + " plus " + lengths[1] + " is " + lengths[0].add(lengths[1]));
    System.out.println("Subtraction: " + lengths[0] + " minus " + lengths[1]+ " is " + lengths[0].subtract(lengths[1]));
    System.out.println("Multiplication: " + lengths[0] + " times 10 is " + lengths[0].multiply(10));
    System.out.println("Division: " + lengths[0] + " divided by 10 is " + lengths[0].divide(10));
    System.out.println("Area: "  + lengths[0] + " by " + lengths[1] + " is " + lengths[0].area(lengths[1]) + " square mm");

    if(lengths[0].compare(lengths[1]) > 0)
      System.out.println("Length "+ lengths[0] + " is greater than length " +	lengths[1]);
    else if(lengths[0].compare(lengths[1]) < 0)
      System.out.println("Length "+ lengths[0] + " is less than length " + lengths[1]);
    else
      System.out.println("Length "+ lengths[0] + " is the same length as length " + lengths[1]);
  }
}
