// BASE CLASS FOR SHAPES - NO LONGER AN ABSTRACT CLASS SINCE IT HAS 
// NO ABSTRACT METHODS. Since the move() method is implemented here, 
// for it to work shapes that are based on this class must be defined 
// relative to the reference point, position. The alternative would be 
// to implement a separate move() method in each derived class.

public class Shape
{
  protected Point position;     // Position of a shape.

  // Method to move a shape:
  public void move(double xDelta, double yDelta)
  {
    // Move the shape by xDelta in x, and yDelta in y:
    position.x += xDelta;		
    position.y += yDelta;
  }

}
