//CHAPTER 8, SOLUTION 3

import java.io.*;

public class TextString
{
  private static BufferedWriter out = null;  // Stream to output file

	public static void main(String[]args)
	{
		String myStr=new String("the cat sat on the mat");		// String to be segmented.
		int count=0;									              // Number of substrings.
		char separator = ' ';							          // Substring separator.
		int index=0;									              // Substring start index.

		try
		{
			File aFile=new File("TextString.txt");
			aFile.createNewFile();						

			// Create a buffered byte output stream:
			out = new BufferedWriter(
			             new FileWriter(aFile));
		
			// Determine the number of words:
			do
			{
				++count;								// Increment count of substrings.
				++index;								// Move past last position.
				index=myStr.indexOf(separator, index);
			}
			while(index!=-1);

			// Extract the substring into an array:
			String[]words = new String[count];
			index=0;                  // Start index							
			int endIndex=0;						// Word end index.
			
			for(int i=0; i<count; i++)
			{
				endIndex=myStr.indexOf(separator, index);	   // Find next separator.

				if(endIndex==-1)                             // If it is not found,
					words[i]=myStr.substring(index);		       // extract to the end;
				else												// otherwise
					words[i]=myStr.substring(index, endIndex); // to end index.

				index=endIndex+1;						// Set start for next cycle.
			}
			// Recombine words & write result to the .txt file 
      addWord("\n", words);
      out.close();
		}
		catch(IOException e)
		{
			System.out.println("IO exception thrown: " + e);
		}
	}

  // Method to append all permutations of words from the words array
	// and write them to the stream, out, which is defined externally.
	private static void addWord(String str, String[] words)
	{
    // If there is only one word to add, add it and write the string
    if(words.length == 1)
    try
    {
      out.write(str + " " + words[0]);
      return;
    }
    catch(IOException e)
    {
      System.out.println("Error writing file:\n"+e);
      System.exit(1);
    }

    String[] newWords = null;
    int k = 0;    
	  for(int i = 0 ; i<words.length; i++)
	  {
	    newWords = new String[words.length-1];
      k = 0;	    
	    for(int j = 0 ; j<words.length ; j++)
	    if(j != i)
	      newWords[k++] = words[j];
	    
      addWord(str + " " + words[i], newWords);        
	  }
	}
}
