import java.io.*;
public class FormattedInput extends StreamTokenizer
{
  // Constructor:
  public FormattedInput()
  {
    // Call the base class constructor for standard input:
    super(new FileReader(FileDescriptor.in));
  }

  // Method to read an int value:
  public int intRead()
  {
    try
    {
      for(int i = 0; i < 5; i++)
      {
        if(nextToken()==TT_NUMBER)
          return (int)nval;   	// Value is numeric, so return as int.
        else
        {
          System.out.println("Incorrect input: " + sval +  " Re-enter an integer");
          continue;            	// Retry the read operation.
        }
      }
      System.out.println("Five failures reading an int value - program terminated");
      System.exit(1);          	// End the program.
      return 0;
    }

    catch(IOException e)       	// Error reading in nextToken().
    {
      System.out.println(e);   	// Output the error.
      System.exit(1);          	// End the program.
      return 0;
    }
  }

  // Method to read a floatingvalue:
  public double doubleRead()
  {
    try
    {
      for(int i = 0; i < 5; i++)
      {
        if(nextToken()==TT_NUMBER)
          return (double)nval;   // Value is numeric, so return as int.
        else
        {
          System.out.println("Incorrect input: " + sval +  " Re-enter a numeric value");
          continue;            	// Retry the read operation.
        }
      }
      System.out.println("Five failures reading a floating point value - program terminated");
      System.exit(1);          	// End the program.
      return 0;
    }

    catch(IOException e)       	// Error reading in nextToken().
    {
      System.out.println(e);   	// Output the error.
      System.exit(1);          	// End the program.
      return 0;
    }
  }
}
