import java.io.*;

// Program to write names to a file:
public class StoreNameObjects
{
  static public void main(String[] args)
  {
    String name;                      		// Stores a name input string.
    String firstname;                 		// Stores the first name.
    String surname;                   		// Stores the surname.
    Name aName;                       		// References a Name object.
    String namesFile = "Names.txt";   		// File name to store names.
    BufferedReader keyboard = new BufferedReader(new InputStreamReader(System.in));
    ObjectOutputStream out = null;    		// File output stream.
    ObjectInputStream in = null;     		// File input stream.

    try
    {
      out = new ObjectOutputStream(                             // Object output stream
             new BufferedOutputStream(       
                           new FileOutputStream(namesFile)));   // for names file.

      System.out.println("Enter surname followed by first name separated by a space - press Enter to end:");

      // Read names from the keyboard and write them to the file:
      int space;                              			// Index of space between surname and first.                                
      while((name=keyboard.readLine()).length()>0)
      {
        if((space = name.indexOf(' ')) <0)           		// Check that there is a space.
        {
          System.out.println("Enter a surname and first name separated by a space");
          continue;
        }
        surname = name.substring(0, space);          		// Extract the surname.
        firstname = name.substring(space+1);            	// Extract the first name.
        out.writeObject(new Name(firstname,surname));   	// Write the name to the file as Name object.
      }

    }
    catch(IOException e)
    {
      System.err.println("Error Writing names file\n"+e);
      System.exit(1);                                   	// End the program.
    }
 
 
    // Close the file, display the names saved to the file by reading them back in:
    System.out.println("A list of all names in the file:");
    try
    {
      out.close();			                       	// Close the output stream.
      in = new ObjectInputStream(                              	// Object input stream
             new BufferedInputStream(       
                           new FileInputStream(namesFile)));   	// for names file.
      try
      {
        while((aName = (Name)in.readObject())!=null)		// Read until EOF.
	  System.out.println("Name is: "+aName);
      }

      catch(EOFException e)
      { // Since this is normal you could do nothing here
	System.out.println("End of File reached");              // Report end of file.
      }

      catch(IOException e)
      {
	System.err.println("IOException in reading Objects");
	System.err.println(e);
        System.exit(1);                                   	// End the program.
      }

      catch(ClassNotFoundException e)
      {
	System.err.println(e);
        System.exit(1);                                   	// End the program.
      }

      finally
      {
        if(in != null)
	  in.close();                                     	// Ensure the file is closed.
      }
    }

    // Handle IO exception from file close:
    catch(IOException e)
    {
      System.err.println(e);
      System.exit(1);                                   	// End the program.
    }
  }
}
