import java.io.*;

// Class to define an object representing a name:
class Name implements Serializable
{
  private String firstname;
  private String surname;
 
  // Default constructor:
  public Name(){}

  // Constructor:
  public Name(String firstname, String surname)
  {
    this.firstname = firstname;
    this.surname = surname;
  }
  
  // Returns String representation of a name:
  public String toString()
  {
    return firstname+" "+surname;
  }

  // Compares two Name objects: returns -1 if this is less than the argument;
   			     // returns  0 if this is equal to the argument;
  			     // returns +1 if this is greater than the argument. 

  public int compareTo(Name name)
  {
    if(surname.compareTo(name.surname)<0)
      return -1;
    if(surname.compareTo(name.surname)>0)
      return 1;

    // Here the surnames are equal:
    if(firstname.compareTo(name.firstname)<0)
      return -1;
    if(firstname.compareTo(name.firstname)>0)
      return 1;

    // Here the surnames and the first names are equal:
    return 0;
  }
}
