import java.util.*;

public class DeckCards
{
  static Stack deck;			// Stack object to store deck of cards.

  public static void main(String args[])
  {
    shuffleDeck();			// Shuffle the deck of cards.
    try
    {
      dealHands(4,13);			// Deal 4 hands of 13 cards each from the deck.
    }

    catch(NotEnoughCardsException e)	// Handle an exception
    {
      System.out.println(e);
    }
  }

  public static void shuffleDeck()
  {
    deck = new Stack();                          // Stack object to store shuffled deck of cards.
    Vector oDeck = orderedDeck();                // Vector object to store ordered deck of cards.

    Random card = new Random();
    while( oDeck.size()>0 )
    {
      int chosen = card.nextInt(oDeck.size());    // Chose a random number 0 to
                                                  // number of cards left on deck.
      deck.push(oDeck.elementAt(chosen));         // Push chosen card onto stack.
      oDeck.removeElementAt(chosen);              // Remove card from ordered deck.
    }
  }

  // Method to store an ordered deck of cards:
  public static Vector orderedDeck()
  {
    Vector oDeck = new Vector(52);                // Vector object to store ordered deck.

    char[] suits = {'C', 'D', 'H', 'S'};
    String value = null;                          // Stores the card value.

    for(int j=0 ; j<suits.length ;j++)
      for(int i=1 ; i<=13 ; i++)
      {
        switch(i)
        {
          case 11:
            value = "J";    // Jack.
            break;
          case 12:
            value = "Q";    // Queen.
            break;
          case 13:
            value = "K";    // King.
            break;
          case 1:
            value = "A";    // Ace.
            break;
          default:
            value = Integer.toString(i);
         }

	       oDeck.addElement(value+suits[j]);
       }
    return oDeck;
  }

  public static void dealHands(int hands, int cards) throws
						NotEnoughCardsException
  {
    // Check that there are enough cards left on the deck...
    if((hands*cards) > deck.size())
      throw new NotEnoughCardsException("dealHands: Not enough cards...");

    // Deal the hands:
    for(int i=0 ; i<hands ; i++)
    {
      System.out.println("\nHand number " + (i+1) + " is:");
      for(int j=0 ; j<cards ; j++)
        System.out.print(" " + deck.pop());
    }
  }
}

