import java.io.*;

public class Person implements Serializable, Comparable
{
	// Read a name from the keyboard:
	public static Person readPerson()
	{
		FormattedInput in = new FormattedInput();
		System.out.println("\nEnter first name:");	// Read in the first name and trim blanks:
		String firstName = in.stringRead().trim();
		System.out.println("\nEnter surname:");		// Same for surname:
		String surname = in.stringRead().trim();
		return new Person(firstName, surname);
	}

	// Overriden default method returning true when two different Person objects 
	public boolean equals(Object person)			// contain identical data values:
	{
		return compareTo(person) == 0;
	}

	// Overriden default method to generate hashcodes for the two Person strings:
	public int hashCode()
	{
		return 7*firstName.hashCode() + 13*surname.hashCode();
	}

	// Constructor:
	public Person(String firstName, String surname)
	{
		this.firstName = firstName;
		this.surname = surname;
	}

	public String toString()
	{
		return firstName + " " + surname;
	}

	// Compare Person objects using method belonging to Comparable interface:
	public int compareTo(Object person)
	{
		int result = surname.compareTo(((Person)person).surname);
		return result == 0 ? firstName.compareTo(((Person)person).firstName) : result;
	}

	private String firstName;
	private String surname;
}