// Operates a blackjack game - no splits
class Blackjack
{		
	public static void main(String[]Args)
	{			
    int minDeckSize = deck.size()/4;                          // Minimum deck size - to defeat card counters

    while(true)
    {
      if(deck.size() <= minDeckSize)
      {
        System.out.println("New deck!");
        deck = new BlackjackDeck();
      }
		  playerHand = deck.dealHand();				        // Deal the player's hand
		  dealerHand = deck.dealHand();				        // Deal the dealer's hand
		  System.out.println("You were dealt: " + playerHand.asDealt());
		  System.out.println("Dealer was dealt: " + dealerHand.asDealt());
      System.out.print("    Place your bet($1 minimum - whole dollars only) : ");		  
      stake = getStake();

      playerPlay();
      if(!playerHand.isBust())
        dealerPlay();

      System.out.print("\n\nAnother game(Y orN)? :");
      if(!yes())
       break;
    }

    // End of game
    System.out.println("\nYou "+ (dealerCash>0 ? "lost" : "won") + " a total of $"+ Math.abs(dealerCash));
	}

	private static void playerPlay()
	{
		System.out.println("\nYour hand is: " + playerHand);
	  if(playerHand.isBlackjack())
	  {
      System.out.println("You have blackjack!");
      return;
	  }

    while(true)
    {
      System.out.print("Another card(Y or N)? : ");        
      if(yes())
      {
        System.out.println("Your hand is now: " + deck.dealCard(playerHand));
    
        if(playerHand.isBust())
        {
          System.out.println("Bust! You lose!");
          dealerCash += stake;
          return;
        }
      }
      else
        return;        
    }
	}

	private static void dealerPlay()
	{
    System.out.println("\nDealer hand is: " + dealerHand);
    if(dealerHand.isBlackjack())
    {
      System.out.println("Dealer has blackjack! You lose!");
      dealerCash += stake;
      return;
    }

    if(playerHand.isBlackjack())
    {
      System.out.println("You win! Twice the stake for blackjack!");
      dealerCash -= 2*stake;
      return;
    }

    int playerHandValue = playerHand.value();
    if(playerHand.hasAce() && playerHandValue<12)
      playerHandValue += 10;
      
    int dealerHandValue = 0;
    while(true)
    {
      dealerHandValue = dealerHand.value();
      if(dealerHandValue<12 && dealerHand.hasAce())
        dealerHandValue += 10;
      System.out.println("Dealer has: " + dealerHand);

      if(dealerHandValue==playerHandValue)
      {
        System.out.println("\nIt's a standoff. You get your stake back.");
        return;
      }

      if(dealerHandValue>playerHandValue)
      {
        System.out.println("\nYou lose!");
        dealerCash += stake;
        return;
      }

      if(deck.dealCard(dealerHand).isBust())
      {
        System.out.println("Dealer has: " + dealerHand + "\n Busted! You win!");
        dealerCash -= stake;
        return;

      }
    }
  }

  private static int getStake()
  {
    return in.intRead();
  }

  private static boolean yes()
  {
    return in.stringRead().equalsIgnoreCase("Y");
  }
          
  private static FormattedInput in = new FormattedInput();      // Keyboard input
  private static int stake = 0;                                 // Player stake in dollars
  private static int dealerCash = 0;                            // Dealer's winnings(or losings!)

  private static BlackjackDeck deck = new BlackjackDeck();		  // The card deck for the game
  private static BlackjackHand playerHand;                      // The player's hand
  private static BlackjackHand dealerHand;                      // The dealer's hand

}
