import java.util.*;
public class BlackjackDeck
{
  // Default is two decks
  public BlackjackDeck()
  {  this(2);  }
    
  // This constructor creates a blackjack deck by selecting cards randomly
  // from a vector that contains cards from a given number of standard decks.
  // It would be easier to use Collections.shuffle() on the stack !!
  public BlackjackDeck(int numberOfDecks)
  {
    numberOfDecks = Math.max(numberOfDecks,1);             // Ensure at least one deck
    int cardCount = numberOfDecks*52;
    
    // Create standards decks to be used for the blackjack deck
    Vector standardDecks = new Vector(cardCount);
    for(int i = 0 ; i<numberOfDecks ; i++)
      for(int theSuit=Card.HEARTS; theSuit<=Card.SPADES; theSuit++)
        for(int theValue=Card.ACE; theValue<=Card.KING; theValue++)
          standardDecks.add(new Card(theValue, theSuit));

   Random random = new Random();

   // Select cards at random from standard decks to put in the blackjack deck
   while(standardDecks.size()>0)
     blackjackDeck.push(standardDecks.remove(random.nextInt(standardDecks.size())));          
  }

  // Deal a blackjack hand of two cards
  public BlackjackHand dealHand()
	{	
		BlackjackHand hand=new BlackjackHand();				  // Creates the empty hand.
		
		for(int i=0; i<2; i++)
		  if(blackjackDeck.isEmpty())
		  {
		    System.out.println("Deck is exhausted!");
		    return null;
		  }
		  else
			  hand.add((Card)blackjackDeck.pop());		    // Pops cards off the deck and into the hand.

		return hand;
	}

	// Deal one card into a given hand
	public BlackjackHand dealCard(BlackjackHand hand)
	{
		hand.add((Card)blackjackDeck.pop());
		return hand;
	}

	public int size()
	{ return blackjackDeck.size();  }

	private Stack blackjackDeck = new Stack();			// Deck of cards for blackjack game
}
