import java.util.Vector;
public class BlackjackHand
{
	// Add a card to the hand
	public void add(Card card)
	{
		hand.add(card);
	}

	public int value()
	{
    int handValue = 0;
    int cardValue = 0;
    for(int i = 0 ; i< hand.size() ; i++)
    {
      cardValue = ((Card)(hand.elementAt(i))).value();
      handValue += cardValue > 10 ? 10 : cardValue;
    }
      
    return handValue;

	}

  // Tests for blackjack
  public boolean isBlackjack()
  {
    if(hand.size() == 2 && hasAce() && hasTen())
      return true;
    else
      return false;
  }

  // Calculates whether the value of a hand with Ace as 1 exceeds 21
  public boolean isBust()
  {   return value() > 21;  }

  // Tests for an Ace in the hand
  public boolean hasAce()
  {
    for(int i = 0 ; i< hand.size() ; i++)
      if(((Card)(hand.elementAt(i))).value()==Card.ACE)
        return true;

    return false;
  }

  // Tests for a 10, J, Q, or K in the hand
  public boolean hasTen()
  {
    for(int i = 0 ; i< hand.size() ; i++)
      if(((Card)(hand.elementAt(i))).value() >= 10)
        return true;

    return false;
  }
  public String asDealt()
  { return "XX " + (Card)(hand.elementAt(1));  }

  public String toString()
  {
    String str = ((Card)(hand.elementAt(0))).toString();
    for(int i = 1 ; i< hand.size() ; i++)
      str = str + " " + (Card)(hand.elementAt(i));
    return str;

  }

	private Vector hand=new Vector();			// Stores the cards in the hand
}
