// *** Virtually unchanged from the class in the main text, apart from dropping the
// compareTo() method and the implementation of the Comparable interface.

class Card
{
	// Suit values
	public static final int HEARTS=0;
	public static final int CLUBS=1;
	public static final int DIAMONDS=2;
	public static final int SPADES=3;

	// Card face values   
	public static final int ACE=1;		
	public static final int JACK=11;
	public static final int QUEEN=12;
	public static final int KING=13;

	private int suit;
	public int value;

	// Constructor:
	public Card(int value, int suit) throws IllegalArgumentException
	{
		if(value>=ACE && value<=KING)
			this.value=value;
		else
			throw new IllegalArgumentException("Invalid card value");
		if(suit>=HEARTS && suit<=SPADES)
			this.suit=suit;
		else
			throw new IllegalArgumentException("Invalid suit");
	}

	// Return the value of a card
	public int value()
	{	  return value;  }

	// Method to display a card:
	public String toString()
	{
		String cardStr;

		if (value==ACE)
			cardStr="A";
		else if (value==JACK)	
			cardStr="J";
		else if (value==QUEEN)	
			cardStr="Q";
		else if (value==KING)
			cardStr="K";
		else
			cardStr=Integer.toString(value);

		switch(suit)
		{
			case CLUBS:	cardStr+="C";
						break;
			case DIAMONDS:cardStr+="D";
						break;
			case HEARTS:cardStr+="H";
						break;
			case SPADES:cardStr+="S";
						break;
		}
		return cardStr;
	}
}
