// Ouputs the Zodiac sign corresponding to a given date.
import java.util.*;
import java.text.DateFormatSymbols;

class TryCalendar
{
	public static void main(String[]args)
	{
		String [] zodiac = {  "CAPRICORN", "AQUARIUS", "PISCES", 
		                      "ARIES",     "TAURUS",   "GEMINI", 
		                      "CANCER",    "LEO",      "VIRGO",  
						              "LIBRA",     "SCORPIO",  "SAGITTARIUS" 
						           };

    // Dates for the start of each sign period, starting with Aquarius
		GregorianCalendar[] signStartDates = { new GregorianCalendar(2000, Calendar.JANUARY, 21),
		                                       new GregorianCalendar(2000, Calendar.FEBRUARY, 20),
		                                       new GregorianCalendar(2000, Calendar.MARCH, 21),
		                                       new GregorianCalendar(2000, Calendar.APRIL, 21),
		                                       new GregorianCalendar(2000, Calendar.MAY, 22),
		                                       new GregorianCalendar(2000, Calendar.JUNE, 22),
		                                       new GregorianCalendar(2000, Calendar.JULY, 24),
		                                       new GregorianCalendar(2000, Calendar.AUGUST, 24),
		                                       new GregorianCalendar(2000, Calendar.SEPTEMBER, 24),
		                                       new GregorianCalendar(2000, Calendar.OCTOBER, 24),
		                                       new GregorianCalendar(2000, Calendar.NOVEMBER, 23),
		                                       new GregorianCalendar(2000, Calendar.DECEMBER, 22)
		                                     };
			
		GregorianCalendar birthday = getDate();           // Get the calendar for a birthday

		String yourSign = zodiac[0];                      // Set CAPRICORN as default
    for(int i = 0; i<signStartDates.length ; i++)
		  if(birthday.before(signStartDates[i]))          // Check if birthday is before a start date
		  {
		    yourSign = zodiac[i];                         // If it is, that determines the sign
		    break;
		  }
    // If none was set in the loop, it must be 22nd Dec or later so default applies
		  
		System.out.println("Your zodiacal sign is: " + yourSign);
	}

	private static GregorianCalendar getDate()
	{
	  int day = 0;
	  int month = 0;
	  for(int i = 0 ; i<5 ; i++)
	  {
		  System.out.println("Enter a birthday as dd mm: ");
		  day=in.intRead();
	  	month=in.intRead();
	  	if(month>0 && month<13 && day>0 && day <= monthDays[month-1])
	  	  return new GregorianCalendar(2000, month-1, day);
	  	System.out.println("Invalid date entered. Try again.");
	  }
	  System.out.println("Five invalid dates entered. Sorry - no more tries...");
    System.exit(1);
    return null;
	}

  private static int[] monthDays = {31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
	private static FormattedInput in=new FormattedInput();
}
