import java.util.Random;

public class BankOperation
{
  // Bank Account information:
  static int[] initialBalance = {500, 800};  			// The initial account balances.
  static int[] totalCredits = new int[initialBalance.length];  	// Total credits.
  static int[] totalDebits = new int[initialBalance.length];   	// Total debits.
  static int[] nCredits = new int[initialBalance.length]; 	// Number of credits.
  static int[] nDebits = new int[initialBalance.length];  	// Number of debits.
  static Account[] accounts = new Account[initialBalance.length];

  public static void main(String[] args)
  {
    String[] supervisorNames = {"Mr. Smith", "Mrs. Jones"};

    // Create the bank
    Bank theBank = new Bank();             // Create a bank.

    // Create the supervisors:
    Supervisor[] supervisors = new Supervisor[supervisorNames.length];
    for(int i = 0; i < supervisors.length; i++)
      supervisors[i] = new Supervisor(theBank, supervisorNames[i]);

    // Create the threads for the supervisors and start them off:
    Thread[] supervisorThread = new Thread[supervisors.length];
    for(int i = 0; i < supervisors.length; i++)
    {
      supervisorThread[i] = new Thread(supervisors[i]);
      supervisorThread[i].setDaemon(true);
      supervisorThread[i].start();
    }

    // Sit here until the Supervisors say they're done:
    for(int i=0; i < supervisors.length; i++)
      supervisors[i].isBusy();

    // Now output the results:
    for(int i = 0; i < BankOperation.accounts.length; i++)
      System.out.println("Account Number:"+accounts[i].getAccountNumber()+"\n"+
         "Number of credits   :  " + nCredits[i] + "\n" +
         "Number of debits    :  " + nDebits[i] + "\n" +
         "Original balance    : $" + initialBalance[i] + "\n" +
         "Total credits       : $" + totalCredits[i] + "\n" +
         "Total debits        : $" + totalDebits[i] + "\n" +
         "Final balance       : $" + accounts[i].getBalance() + "\n" +
         "Should be           : $" + (initialBalance[i] + totalCredits[i] -
                                        totalDebits[i]) + "\n");
  }
}