import javax.swing.*;
import java.awt.*;

public class SqFrame extends JFrame 
{
   public SqFrame() 
   {
      super();
   }

   public SqFrame(String title) 
   {
      super(title);

      Toolkit theKit = this.getToolkit();
      Dimension wndSize = theKit.getScreenSize();

      this.setBounds((wndSize.width/2 - wndSize.height/4), wndSize.height/4,  // Position.
                     wndSize.height/2, wndSize.height/2);                     // Size.

      this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
      addButtons();
      addMenu();
      this.setVisible(true);
   }

   void addButtons() 
   {
      // Create a JPanel to hold the buttons: 
      JPanel gridPanel = new JPanel();

      GridLayout grid = new GridLayout(6, 1, 5, 0); // 6 rows, 1 column, 
                                                    // hgap of 5 pixels, no vgap. 
      // Set gridPanel to have a grid layout:
      gridPanel.setLayout(grid);

      // Add the six buttons, suitably labelled:
      JButton button;
      for (int i = 1; i <= 6; i++)
         gridPanel.add(button = new JButton("Button" + i));

      // Use the border layout on the container:
      BorderLayout border = new BorderLayout();

      Container content = this.getContentPane();
      content.setLayout(border);

      // And add the gridPanel to this border layout in the west:
      content.add(gridPanel, BorderLayout.WEST);
   }

   void addMenu() 
   {
      // Create and add the menu bar to the Frame:
      JMenuBar menuBar = new JMenuBar();

      setJMenuBar(menuBar);

      // Add the menu headings, with mnemonics:
      JMenu fileMenu = new JMenu("File");
      JMenu editMenu = new JMenu("Edit");
      JMenu windowMenu = new JMenu("Window");
      JMenu helpMenu = new JMenu("Help");

      menuBar.add(fileMenu);
      menuBar.add(editMenu);
      menuBar.add(windowMenu);
      menuBar.add(helpMenu);

      // Add menu elements to the Edit menu:
      JMenuItem firstItem = new JMenuItem("Beginning Java 2");
      JMenuItem secondItem = new JMenuItem("Professional Java Server Programming");
      JMenuItem thirdItem = new JMenuItem("Instant HTML Prog Ref");

      editMenu.add(firstItem);
      editMenu.add(secondItem);
      editMenu.add(thirdItem);

      editMenu.addSeparator();

      JMenuItem fourthItem = new JMenuItem("Satsuma");
      JMenuItem fifthItem = new JMenuItem("Apple");
      JMenuItem sixthItem = new JMenuItem("Banana");

      editMenu.add(fourthItem);
      editMenu.add(fifthItem);
      editMenu.add(sixthItem);
   }
}