import javax.swing.*;
import java.awt.*;

public class SqFrame extends JFrame 
{
   public SqFrame(String title) 
   {
      super(title);

      Toolkit theKit = this.getToolkit();
      Dimension wndSize = theKit.getScreenSize();

      this.setBounds((wndSize.width/2 - wndSize.height/4), wndSize.height/4,  // Position.
                     wndSize.height/2, wndSize.height/2);                     // Size.

      this.setDefaultCloseOperation(EXIT_ON_CLOSE);
      addButtons();
      addMenu();
      this.setVisible(true);
   }

   void addButtons() 
   {
      // Create a JPanel to hold the buttons: 
      JPanel gridPanel = new JPanel();

      GridLayout grid = new GridLayout(6, 1, 5, 0); // 6 rows, 1 column, 
                                                    // hgap of 5 pixels, no vgap. 
      // Set gridPanel to have a grid layout:
      gridPanel.setLayout(grid);

      // Add the six buttons, suitably labelled:
      JButton button;
      for (int i = 1; i <= 6; i++)
         gridPanel.add(button = new JButton("Button" + i));

      // Use the border layout on the container:
      BorderLayout border = new BorderLayout();

      Container content = this.getContentPane();
      content.setLayout(border);

      // And add the gridPanel to this border layout in the west:
      content.add(gridPanel, BorderLayout.WEST);
   }

   void addMenu() 
   {
      // Create and add the menu bar to the Frame:
      JMenuBar menuBar = new JMenuBar();

      setJMenuBar(menuBar);

      // Add the menu headings, with mnemonics:
      JMenu fileMenu = new JMenu("File");
      JMenu editMenu = new JMenu("Edit");
      JMenu windowMenu = new JMenu("Window");
      JMenu helpMenu = new JMenu("Help");

      fileMenu.setMnemonic('F');
      editMenu.setMnemonic('E');
      windowMenu.setMnemonic('W');
      helpMenu.setMnemonic('H');

      menuBar.add(fileMenu);
      menuBar.add(editMenu);
      menuBar.add(windowMenu);
      menuBar.add(helpMenu);

      // Add menu elements to the Edit menu:
      JMenuItem firstItem = new JMenuItem("Beginning Java 2");
      JMenuItem secondItem = new JMenuItem("Professional Java Server Programming");
      JMenuItem thirdItem = new JMenuItem("Instant HTML Prog Ref");

      editMenu.add(firstItem);
      editMenu.add(secondItem);
      editMenu.add(thirdItem);

      firstItem.setAccelerator(KeyStroke.getKeyStroke('B', Event.CTRL_MASK));
      secondItem.setAccelerator(KeyStroke.getKeyStroke('P', Event.CTRL_MASK));
      thirdItem.setAccelerator(KeyStroke.getKeyStroke('I', Event.CTRL_MASK));

      editMenu.addSeparator();

      JMenuItem fourthItem = new JMenuItem("Satsuma");
      JMenuItem fifthItem = new JMenuItem("Apple");
      JMenuItem sixthItem = new JMenuItem("Banana");

      editMenu.add(fourthItem);
      editMenu.add(fifthItem);
      editMenu.add(sixthItem);

      fourthItem.setAccelerator(KeyStroke.getKeyStroke('S', Event.CTRL_MASK));
      fifthItem.setAccelerator(KeyStroke.getKeyStroke('A', Event.CTRL_MASK));
      sixthItem.setAccelerator(KeyStroke.getKeyStroke('N', Event.CTRL_MASK));

      editMenu.addSeparator();

      // Add an extra pull-down menu to the Edit menu:
      JMenu extraMenu = new JMenu("Vegetables!");
      editMenu.add(extraMenu);

      JMenuItem seventhItem = new JMenuItem("Turnip");
      JMenuItem eighthItem = new JMenuItem("Artichoke");
      JMenuItem ninthItem = new JMenuItem("Leek");

      extraMenu.add(seventhItem);
      extraMenu.add(eighthItem);
      extraMenu.add(ninthItem);

      seventhItem.setAccelerator(KeyStroke.getKeyStroke('T', Event.CTRL_MASK));
      eighthItem.setAccelerator(KeyStroke.getKeyStroke('R', Event.CTRL_MASK));
      ninthItem.setAccelerator(KeyStroke.getKeyStroke('L', Event.CTRL_MASK));
   }
}
