// Applet to generate lottery entries.
import javax.swing.*;
import javax.swing.border.*;           // For component borders.
import java.util.Random;               // For random number generator.
import java.util.Collections;
import java.util.Vector;
import java.awt.*;
import java.awt.event.*;

public class Lottery6 extends JApplet
{

  // Generate numberCount random selections from the values array:
  static int[] getNumbers()
  {
    int[] numbers = new int[numberCount];		// Store for the numbers to be returned.
    int candidate = 0;							// Stores a candidate selection.
    for(int i = 0; i < numberCount; i++)		// Loop to find the selections.
    {
      search:
      for(;;)									// Loop to find a new selection
      {											// different from any found so far.
        candidate = values[choice.nextInt(values.length)];
        for(int j = 0 ; j<i ; j++)				// Check against existing selections.
          if(candidate==numbers[j])				// If it is the same
            continue search;					// get another random selection.

        numbers[i] = candidate;					// Store the selection in numbers array
        break;									// and go to find the next.
      }
    }
    return numbers;								// Return the selections.
  }

  // Initialize the applet:
  public void init()
  {
    // Set up the selection buttons:
    Container content = getContentPane();
    content.setLayout(new BorderLayout());				// Set the layout for the applet.

    content.add(toolBar, BorderLayout.NORTH);

    MouseHandler mouseHandler = new MouseHandler();		// Create the listener.

    JButton button = toolBar.add(lotteryAction = new LotteryAction("Lucky Numbers!"));
    button.setBorder(BorderFactory.createRaisedBevelBorder());
    button.addMouseListener(mouseHandler);

    button = toolBar.add(colorAction = new LotteryAction("Change Color"));
    button.setBorder(BorderFactory.createRaisedBevelBorder());
    button.addMouseListener(mouseHandler);

    button = toolBar.add(orderAction = new LotteryAction("Order Numbers"));
    button.setBorder(BorderFactory.createRaisedBevelBorder());
    button.addMouseListener(mouseHandler);

/*    content.setLayout(new GridLayout(0,1));			// Set the layout for the applet.

    // Add the pane containing control buttons:
    JPanel controlPane = new JPanel(new FlowLayout(FlowLayout.CENTER, 5, 10));  

    // Add the two control buttons:
    Dimension buttonSize = new Dimension(100,20);
    pickButton.setPreferredSize(buttonSize);
    pickButton.setBorder(BorderFactory.createRaisedBevelBorder());

    colorButton.setPreferredSize(buttonSize);
    colorButton.setBorder(BorderFactory.createRaisedBevelBorder());

    orderButton.setPreferredSize(buttonSize);
    orderButton.setBorder(BorderFactory.createRaisedBevelBorder());

    pickButton.addActionListener(new ActionListener()
                                    {
                                      public void actionPerformed(ActionEvent e)
                                      {
                                        int[] numbers = getNumbers(); 
                                        for(int i = 0; i < numberCount; i++)
                                          ((Selection)luckyNumbers.get(i)).setValue(numbers[i]);
                                      }
                                    });

    colorButton.addActionListener(new ActionListener()
                                    {
                                      public void actionPerformed(ActionEvent e)
                                      {
                                        Color color = new Color(
                      flipColor.getRGB()^((Selection)luckyNumbers.firstElement()).getBackground().getRGB());
                                        for(int i = 0; i < numberCount; i++)
                                          ((Selection)luckyNumbers.get(i)).setBackground(color);
                                      }
                                    });

    orderButton.addActionListener(new ActionListener()
                                    {
                                      public void actionPerformed(ActionEvent e)
                                      {
                                        Collections.sort(luckyNumbers);
                                        buttonPane.removeAll();
                                        for (int i = 0; i <numberCount; i++)
                                        {
                                          buttonPane.add((Selection)luckyNumbers.get(i));
                                        } 
                                        buttonPane.validate();
                                        buttonPane.repaint();
                                      }
                                    });

    controlPane.add(pickButton);
    controlPane.add(colorButton);
    controlPane.add(orderButton);

    content.add(controlPane);
*/
    // Set up the panel to hold the lucky number buttons (let's have a fancy panel border):
    buttonPane.setBorder(BorderFactory.createTitledBorder(
                         BorderFactory.createEtchedBorder(Color.cyan,
                                                          Color.blue),
                                                          "Every One a Winner!"));

    int[] choices = getNumbers();						// Get initial set of numbers.
//    MouseHandler mouseHandler = new MouseHandler();   // Create the listener.

    for(int i = 0 ; i<numberCount ; i++)
    {
      luckyNumbers.add(i, new Selection(choices[i]));
      ((Selection)luckyNumbers.get(i)).addMouseListener(mouseHandler);
      buttonPane.add((Selection)luckyNumbers.get(i));
    }

    content.add(buttonPane);
  }

  class LotteryAction extends AbstractAction {

	// Constructor:
    public LotteryAction(String name) 
	{
      super(name);
    }

    public void actionPerformed(ActionEvent e) 
	{
      // If statements to decide between each button on toolbar - see p809 of Beginning Java 2 (ch 16).
      String name = (String)getValue(NAME);
      if (name.equals(lotteryAction.getValue(NAME))) {
        int[] numbers = getNumbers(); 
        for(int i = 0; i < numberCount; i++)
          ((Selection)luckyNumbers.get(i)).setValue(numbers[i]);
     
      } else if (name.equals(colorAction.getValue(NAME))) {
                                        Color color = new Color(
                      flipColor.getRGB()^((Selection)luckyNumbers.firstElement()).getBackground().getRGB());
                                        for(int i = 0; i < numberCount; i++)
                                          ((Selection)luckyNumbers.get(i)).setBackground(color);
      } else if (name.equals(orderAction.getValue(NAME))) {
        Collections.sort(luckyNumbers);
        buttonPane.removeAll();
        for (int i = 0; i <numberCount; i++)
          buttonPane.add((Selection)luckyNumbers.get(i));
                                        
        buttonPane.validate();			// Re-layout the button pane                                      
        buttonPane.repaint();			// then redraw it.
      }
    }
  }

  // Mouse event handler for a selection button:
  class MouseHandler extends MouseAdapter
  {
    Cursor handCursor = new Cursor(Cursor.HAND_CURSOR);
    Cursor defaultCursor = new Cursor(Cursor.DEFAULT_CURSOR);

    // Handle mouse entering the selection button:
    public void mouseEntered(MouseEvent e)
    {
      e.getComponent().setCursor(handCursor);		// Switch to hand cursor.
    }

    // Handle mouse exiting the selection button:
    public void mouseExited(MouseEvent e)
    {
      e.getComponent().setCursor(defaultCursor);	// Change to default cursor.
    }
  }
 
  // Custom button showing lottery selection (each button listens for its own events):
  class Selection extends JButton
                  implements ActionListener, Comparable
  {

	// Constructor:
    public Selection(int value)
    {
      super(Integer.toString(value));		// Call base constructor and set the label.
      this.value = value;									// Save the value.
      setBackground(startColor);
      setBorder(BorderFactory.createRaisedBevelBorder());	// Add button border.
      setPreferredSize(new Dimension(80,20));
      addActionListener(this);								// Button listens for itself.
    }

    public void actionPerformed(ActionEvent e)
    {
      // Change this selection to a new selection:
      int candidate = 0;
      for(;;)										// Loop to find a different selection:
      {
        candidate = values[choice.nextInt(values.length)];
        if(isCurrentSelection(candidate))			// If it is not different
          continue;									// find another.
        setValue(candidate);						// We have one so set the button value.
        return;
      }
    }

    // Set the value for the selection:
    public void setValue(int value)
    {
      setText(Integer.toString(value));			// Set value as the button label.
      this.value = value;						// Save the value.
    }

    // Check the value for the selection:
    boolean hasValue(int possible)
    {
      return value==possible;					// Return true if equals current value. 
    }

    // Check the current choices:
    boolean isCurrentSelection(int possible)
    {
      for(int i = 0; i < numberCount; i++)							// For each button
        if(((Selection)luckyNumbers.get(i)).hasValue(possible))     // check against possible.
          return true;												// Return true for any =.
      return false;													// Otherwise return false.
    }

    public int compareTo(Object selection)
    {
      // Compare by number they display:
      // int result = value.compareTo(((Selection)selection).value);
      int i = 0;      

      if (value < ((Selection)selection).value)
        i = -1;
      else if (value > ((Selection)selection).value)
        i = 1;

      // Return 
      return i;
    }

    private int value;									// Value for the selection button.
  }

  final static int numberCount = 6;						// Number of lucky numbers.
  final static int minValue = 1;						// Minimum in range.
  final static int maxValue = 49;						// Maximum in range.
  static int[] values = new int[maxValue-minValue+1];	// Array of possible values.

  static												// Initialize array.
  {
    for(int i = 0 ; i<values.length ; i++)
      values[i] = i + minValue;
  }

  // A vector of custom buttons for the selected numbers:
  private Vector luckyNumbers = new Vector(numberCount);

//  JButton pickButton = new JButton("Lucky Numbers!");
//  JButton colorButton = new JButton("Color");
//  JButton orderButton = new JButton("Order Numbers...");

  private JToolBar toolBar = new JToolBar();

  Action lotteryAction, colorAction, orderAction;

  JPanel buttonPane = new JPanel();				// Add the pane containing numbers.

  Color flipColor = new Color(
                      Color.yellow.getRGB()^Color.red.getRGB());	// Swap colors.

  Color startColor = new Color(Color.yellow.getRGB());				// Start color.

  private static Random choice = new Random();			// Random number generator.
}