// Class to define a dialog to choose a color
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.awt.event.*;
import java.awt.geom.*;

class PropertiesDialog extends JDialog
                 implements Constants,
                            ActionListener          // For buttons etc
{
  // Constructor
  public PropertiesDialog(SketchFrame window)
  {
    // Call the base constructor to create a modal dialog
    super(window, "Element Properties", true);   

    this.window = window;                         // Save the window reference

    // Create the dialog button panel 
    JPanel buttonPane = new JPanel();             // Create the panel to hold buttons

    // Create and add the OK button to the buttonPane
    buttonPane.add(ok = new JButton("OK"));              // Add the OK button
    getContentPane().add(buttonPane, BorderLayout.SOUTH); // Add pane to content pane
    ok.addActionListener(this);


    // Create a panel we can use to contain the different panels for
    // each type of element - we use a CardLayout to switch between them
    propsPanel = new JPanel();
    propsPanel.setLayout(new CardLayout());
    
    Insets i = new Insets(5, 5, 5, 5);
    GridBagConstraints gbc;


    // Set up the line panel
    linePanel = createPanel("Line Element");
    GridBagLayout linePanelGbl = new GridBagLayout();
    linePanel.setLayout(linePanelGbl);

      lineColorLabel = new JLabel("Color:", SwingConstants.RIGHT);
        gbc = new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.EAST,
                                     GridBagConstraints.NONE, i, 0, 0);
        linePanelGbl.setConstraints(lineColorLabel, gbc);

      lineAngleLabel = new JLabel("Angle:", SwingConstants.RIGHT);
        gbc = new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.EAST,
                                     GridBagConstraints.NONE, i, 0, 0);
        linePanelGbl.setConstraints(lineAngleLabel, gbc);

      linePositionLabel = new JLabel("Position:", SwingConstants.RIGHT);
        gbc = new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.EAST,
                                     GridBagConstraints.NONE, i, 0, 0);
        linePanelGbl.setConstraints(linePositionLabel, gbc);
    
      lineDimensionsLabel = new JLabel("Dimensions:", SwingConstants.RIGHT);
        gbc = new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.EAST,
                                     GridBagConstraints.NONE, i, 0, 0);
        linePanelGbl.setConstraints(lineDimensionsLabel, gbc);

      lineColorField = new JTextField(20);
        gbc = new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.WEST,
                                     GridBagConstraints.NONE, i, 0, 0);
        linePanelGbl.setConstraints(lineColorField, gbc);

      lineAngleField = new JTextField(20);
        gbc = new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.WEST,
                                     GridBagConstraints.NONE, i, 0, 0);
        linePanelGbl.setConstraints(lineAngleField, gbc);

      linePositionField = new JTextField(20);
        gbc = new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.WEST,
                                     GridBagConstraints.NONE, i, 0, 0);
        linePanelGbl.setConstraints(linePositionField, gbc);

      lineDimensionsField = new JTextField(20);
        gbc = new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.WEST,
                                     GridBagConstraints.NONE, i, 0, 0);
        linePanelGbl.setConstraints(lineDimensionsField, gbc);


      lineColorField.setEditable(false);
      lineAngleField.setEditable(false);
      linePositionField.setEditable(false);
      lineDimensionsField.setEditable(false);

      linePanel.add(lineColorLabel);
      linePanel.add(lineColorField);
      linePanel.add(lineAngleLabel);
      linePanel.add(lineAngleField);
      linePanel.add(linePositionLabel);
      linePanel.add(linePositionField);
      linePanel.add(lineDimensionsLabel);
      linePanel.add(lineDimensionsField);


    // Set up the rectangle panel
    rectanglePanel = createPanel("Rectangle Element");
    GridBagLayout rectanglePanelGbl = new GridBagLayout();
    rectanglePanel.setLayout(rectanglePanelGbl);
        
      rectangleColorLabel = new JLabel("Color:", SwingConstants.RIGHT);
        gbc = new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.EAST,
                                     GridBagConstraints.NONE, i, 0, 0);
        rectanglePanelGbl.setConstraints(rectangleColorLabel, gbc);

      rectangleAngleLabel = new JLabel("Angle:", SwingConstants.RIGHT);
        gbc = new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.EAST,
                                     GridBagConstraints.NONE, i, 0, 0);
        rectanglePanelGbl.setConstraints(rectangleAngleLabel, gbc);

      rectanglePositionLabel = new JLabel("Position:", SwingConstants.RIGHT);
        gbc = new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.EAST,
                                     GridBagConstraints.NONE, i, 0, 0);
        rectanglePanelGbl.setConstraints(rectanglePositionLabel, gbc);

      rectangleDimensionsLabel = new JLabel("Dimensions:", SwingConstants.RIGHT);
        gbc = new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.EAST,
                                     GridBagConstraints.NONE, i, 0, 0);
        rectanglePanelGbl.setConstraints(rectangleDimensionsLabel, gbc);

      rectangleColorField = new JTextField(20);
        gbc = new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.WEST,
                                     GridBagConstraints.NONE, i, 0, 0);
        rectanglePanelGbl.setConstraints(rectangleColorField, gbc);

      rectangleAngleField = new JTextField(20);
        gbc = new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.WEST,
                                     GridBagConstraints.NONE, i, 0, 0);
        rectanglePanelGbl.setConstraints(rectangleAngleField, gbc);

      rectanglePositionField = new JTextField(20);
        gbc = new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.WEST,
                                     GridBagConstraints.NONE, i, 0, 0);
        rectanglePanelGbl.setConstraints(rectanglePositionField, gbc);

      rectangleDimensionsField = new JTextField(20);
        gbc = new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.WEST,
                                     GridBagConstraints.NONE, i, 0, 0);
        rectanglePanelGbl.setConstraints(rectangleDimensionsField, gbc);


      rectangleColorField.setEditable(false);
      rectangleAngleField.setEditable(false);
      rectanglePositionField.setEditable(false);
      rectangleDimensionsField.setEditable(false);

      rectanglePanel.add(rectangleColorLabel);
      rectanglePanel.add(rectangleColorField);
      rectanglePanel.add(rectangleAngleLabel);
      rectanglePanel.add(rectangleAngleField);
      rectanglePanel.add(rectanglePositionLabel);
      rectanglePanel.add(rectanglePositionField);
      rectanglePanel.add(rectangleDimensionsLabel);
      rectanglePanel.add(rectangleDimensionsField);


    // Set up the circle panel
    circlePanel = createPanel("Circle Element");
    GridBagLayout circlePanelGbl = new GridBagLayout();
    circlePanel.setLayout(circlePanelGbl);
    
      circleColorLabel = new JLabel("Color:", SwingConstants.RIGHT);
        gbc = new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.EAST,
                                     GridBagConstraints.NONE, i, 0, 0);
        circlePanelGbl.setConstraints(circleColorLabel, gbc);

      circleAngleLabel = new JLabel("Angle:", SwingConstants.RIGHT);
        gbc = new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.EAST,
                                     GridBagConstraints.NONE, i, 0, 0);
        circlePanelGbl.setConstraints(circleAngleLabel, gbc);

      circlePositionLabel = new JLabel("Position:", SwingConstants.RIGHT);
        gbc = new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.EAST,
                                     GridBagConstraints.NONE, i, 0, 0);
        circlePanelGbl.setConstraints(circlePositionLabel, gbc);

      circleRadiusLabel = new JLabel("Radius:", SwingConstants.RIGHT);
        gbc = new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.EAST,
                                     GridBagConstraints.NONE, i, 0, 0);
        circlePanelGbl.setConstraints(circleRadiusLabel, gbc);

      circleColorField = new JTextField(20);
        gbc = new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.WEST,
                                     GridBagConstraints.NONE, i, 0, 0);
        circlePanelGbl.setConstraints(circleColorField, gbc);

      circleAngleField = new JTextField(20);
        gbc = new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.WEST,
                                     GridBagConstraints.NONE, i, 0, 0);
        circlePanelGbl.setConstraints(circleAngleField, gbc);

      circlePositionField = new JTextField(20);
        gbc = new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.WEST,
                                     GridBagConstraints.NONE, i, 0, 0);
        circlePanelGbl.setConstraints(circlePositionField, gbc);

      circleRadiusField = new JTextField(20);
        gbc = new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.WEST,
                                     GridBagConstraints.NONE, i, 0, 0);
        circlePanelGbl.setConstraints(circleRadiusField, gbc);


      circleColorField.setEditable(false);
      circleAngleField.setEditable(false);
      circlePositionField.setEditable(false);
      circleRadiusField.setEditable(false);

      circlePanel.add(circleColorLabel);
      circlePanel.add(circleColorField);
      circlePanel.add(circleAngleLabel);
      circlePanel.add(circleAngleField);
      circlePanel.add(circlePositionLabel);
      circlePanel.add(circlePositionField);
      circlePanel.add(circleRadiusLabel);
      circlePanel.add(circleRadiusField);


    // Set up the curve panel
    curvePanel = createPanel("Curve Element");
    GridBagLayout curvePanelGbl = new GridBagLayout();
    curvePanel.setLayout(curvePanelGbl);
    
      curveColorLabel = new JLabel("Color:", SwingConstants.RIGHT);
        gbc = new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.EAST,
                                     GridBagConstraints.NONE, i, 0, 0);
        curvePanelGbl.setConstraints(curveColorLabel, gbc);

      curveAngleLabel = new JLabel("Angle:", SwingConstants.RIGHT);
        gbc = new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.EAST,
                                     GridBagConstraints.NONE, i, 0, 0);
        curvePanelGbl.setConstraints(curveAngleLabel, gbc);

      curvePositionLabel = new JLabel("Position:", SwingConstants.RIGHT);
        gbc = new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.EAST,
                                     GridBagConstraints.NONE, i, 0, 0);
        curvePanelGbl.setConstraints(curvePositionLabel, gbc);

      curvePointsLabel = new JLabel("Points:", SwingConstants.RIGHT);
        gbc = new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.NORTHEAST,
                                     GridBagConstraints.NONE, i, 0, 0);
        curvePanelGbl.setConstraints(curvePointsLabel, gbc);

      curveColorField = new JTextField(20);
        gbc = new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.WEST,
                                     GridBagConstraints.NONE, i, 0, 0);
        curvePanelGbl.setConstraints(curveColorField, gbc);

      curveAngleField = new JTextField(20);
        gbc = new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.WEST,
                                     GridBagConstraints.NONE, i, 0, 0);
        curvePanelGbl.setConstraints(curveAngleField, gbc);

      curvePositionField = new JTextField(20);
        gbc = new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.WEST,
                                     GridBagConstraints.NONE, i, 0, 0);
        curvePanelGbl.setConstraints(curvePositionField, gbc);

      curvePointsArea = new JTextArea(5, 20);
      curvePointsScrollPane = new JScrollPane(curvePointsArea);
        gbc = new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.WEST,
                                     GridBagConstraints.NONE, i, 0, 0);
        curvePanelGbl.setConstraints(curvePointsScrollPane, gbc);

      curveColorField.setEditable(false);
      curveAngleField.setEditable(false);
      curvePositionField.setEditable(false);
      curvePointsArea.setEditable(false);


      curvePanel.add(curveColorLabel);
      curvePanel.add(curveColorField);
      curvePanel.add(curveAngleLabel);
      curvePanel.add(curveAngleField);
      curvePanel.add(curvePositionLabel);
      curvePanel.add(curvePositionField);
      curvePanel.add(curvePointsLabel);
      curvePanel.add(curvePointsScrollPane);


    // Set up the text panel
    textPanel = createPanel("Text Element");
    GridBagLayout textPanelGbl = new GridBagLayout();
    textPanel.setLayout(textPanelGbl);
    
      textColorLabel = new JLabel("Color:", SwingConstants.RIGHT);
        gbc = new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.EAST,
                                     GridBagConstraints.NONE, i, 0, 0);
        textPanelGbl.setConstraints(textColorLabel, gbc);

      textAngleLabel = new JLabel("Angle:", SwingConstants.RIGHT);
        gbc = new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.EAST,
                                     GridBagConstraints.NONE, i, 0, 0);
        textPanelGbl.setConstraints(textAngleLabel, gbc);

      textPositionLabel = new JLabel("Position:", SwingConstants.RIGHT);
        gbc = new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.EAST,
                                     GridBagConstraints.NONE, i, 0, 0);
        textPanelGbl.setConstraints(textPositionLabel, gbc);

      textTextLabel = new JLabel("Text:", SwingConstants.RIGHT);
        gbc = new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.EAST,
                                     GridBagConstraints.NONE, i, 0, 0);
        textPanelGbl.setConstraints(textTextLabel, gbc);

      textFontLabel = new JLabel("Font:", SwingConstants.RIGHT);
        gbc = new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.EAST,
                                     GridBagConstraints.NONE, i, 0, 0);
        textPanelGbl.setConstraints(textFontLabel, gbc);

      textColorField = new JTextField(20);
        gbc = new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.WEST,
                                     GridBagConstraints.NONE, i, 0, 0);
        textPanelGbl.setConstraints(textColorField, gbc);

      textAngleField = new JTextField(20);
        gbc = new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.WEST,
                                     GridBagConstraints.NONE, i, 0, 0);
        textPanelGbl.setConstraints(textAngleField, gbc);

      textPositionField = new JTextField(20);
        gbc = new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.WEST,
                                     GridBagConstraints.NONE, i, 0, 0);
        textPanelGbl.setConstraints(textPositionField, gbc);

      textTextField = new JTextField(20);
        gbc = new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.WEST,
                                     GridBagConstraints.NONE, i, 0, 0);
        textPanelGbl.setConstraints(textTextField, gbc);

      textFontField = new JTextField(20);
        gbc = new GridBagConstraints(1, 4, 1, 1, 0.0, 0.0,
                                     GridBagConstraints.WEST,
                                     GridBagConstraints.NONE, i, 0, 0);
        textPanelGbl.setConstraints(textFontField, gbc);

      textColorField.setEditable(false);
      textAngleField.setEditable(false);
      textPositionField.setEditable(false);
      textTextField.setEditable(false);
      textFontField.setEditable(false);

      textPanel.add(textColorLabel);
      textPanel.add(textColorField);
      textPanel.add(textAngleLabel);
      textPanel.add(textAngleField);
      textPanel.add(textPositionLabel);
      textPanel.add(textPositionField);
      textPanel.add(textTextLabel);
      textPanel.add(textTextField);
      textPanel.add(textFontLabel);
      textPanel.add(textFontField);


    // Phew! Having assembled our panels, we stick them all in the card-
    // laid-out panel

    propsPanel.add(linePanel, lineStr);
    propsPanel.add(rectanglePanel, rectangleStr);
    propsPanel.add(circlePanel, circleStr);
    propsPanel.add(curvePanel, curveStr);
    propsPanel.add(textPanel, textStr);


    getContentPane().add(propsPanel, BorderLayout.CENTER);
    pack();
    setVisible(false);
  }

  JPanel createPanel(String label)
  {
    JPanel panel = new JPanel();
    panel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),
                                                     label));
    return panel;
  }


  // This method is used to set the currently-displayed element. Call before
  // calling setVisible(true)
  public void setElement(Element elem)
  {
    Class elemClass = elem.getClass();
    CardLayout cl = (CardLayout)(propsPanel.getLayout());
    if (elemClass == Element.Line.class)
    {
      Element.Line el = (Element.Line) elem;
      Point pos = el.getPosition();

      lineColorField.setText(el.getColorString());
      lineAngleField.setText(el.getAngle() + " radians");
      linePositionField.setText((int)pos.getX() + ", " + (int)pos.getY());
      lineDimensionsField.setText((int)el.getWidth() + ", " + (int)el.getHeight());

      cl.show(propsPanel, lineStr);
    }
    if (elemClass == Element.Rectangle.class)
    {
      Element.Rectangle el = (Element.Rectangle) elem;
      Point pos = el.getPosition();

      rectangleColorField.setText(el.getColorString());
      rectangleAngleField.setText(el.getAngle() + " radians");
      rectanglePositionField.setText((int)pos.getX() + ", " + (int)pos.getY());
      rectangleDimensionsField.setText((int)el.getWidth() + ", " + (int)el.getHeight());

      cl.show(propsPanel, rectangleStr);
    }
    if (elemClass == Element.Circle.class)
    {
      Element.Circle el = (Element.Circle) elem;
      Point pos = el.getPosition();

      circleColorField.setText(el.getColorString());
      circleAngleField.setText(el.getAngle() + " radians");
      circlePositionField.setText((int)pos.getX() + ", " + (int)pos.getY());
      circleRadiusField.setText(Integer.toString((int)el.getRadius()));

      cl.show(propsPanel, circleStr);
    }
    if (elemClass == Element.Curve.class)
    {
      Element.Curve el = (Element.Curve) elem;
      Point pos = el.getPosition();

      curveColorField.setText(el.getColorString());
      curveAngleField.setText(el.getAngle() + " radians");
      curvePositionField.setText((int)pos.getX() + ", " + (int)pos.getY());

      PathIterator iter = el.getPath().getPathIterator(new AffineTransform());
      double[] coord = new double[6];
      
      StringBuffer points = new StringBuffer();
      
      while (!(iter.isDone()))
      {
        if (iter.currentSegment(coord) == PathIterator.SEG_LINETO)
        {
          points.append(coord[0] + ", " + coord[1] + "\n");
        }
        iter.next();
      }
      curvePointsArea.setText(points.toString());

      cl.show(propsPanel, curveStr);
    }
    if (elemClass == Element.Text.class)
    {
      Element.Text el = (Element.Text) elem;
      Point pos = el.getPosition();

      textColorField.setText(el.getColorString());
      textAngleField.setText(el.getAngle() + " radians");
      textPositionField.setText((int)pos.getX() + ", " + (int)pos.getY());
      textTextField.setText(el.getText());
      textFontField.setText(el.getFont().getSize() + "pt " + el.getFont().getFontName());

      cl.show(propsPanel, textStr);
    }
  }

  public void actionPerformed(ActionEvent e)
  {
    Object source = e.getSource();                // Get the source of the event
    if(source == ok)                              // Is it the OK button?
    {
      setVisible(false);                          // Hide the dialog
    }
  }

  private SketchFrame window;        // The application window
  private JButton ok;                // OK button

  private JPanel linePanel, rectanglePanel, circlePanel, curvePanel, textPanel;
  private JPanel propsPanel;
  private static final String lineStr = "LINE",
                              rectangleStr = "RECTANGLE",
                              circleStr = "CIRCLE",
                              curveStr = "CURVE",
                              textStr = "TEXT";

  private JLabel lineColorLabel, lineAngleLabel,
                 linePositionLabel, lineDimensionsLabel;
  private JTextField lineColorField, lineAngleField,
                     linePositionField, lineDimensionsField;
  private JLabel rectangleColorLabel, rectangleAngleLabel,
                 rectanglePositionLabel, rectangleDimensionsLabel;
  private JTextField rectangleColorField, rectangleAngleField,
                     rectanglePositionField, rectangleDimensionsField;
  private JLabel circleColorLabel, circleAngleLabel,
                 circlePositionLabel, circleRadiusLabel;
  private JTextField circleColorField, circleAngleField,
                     circlePositionField, circleRadiusField;
  private JLabel textColorLabel, textAngleLabel, textPositionLabel,
                 textTextLabel, textFontLabel;
  private JTextField textColorField, textAngleField, textPositionField,
                     textTextField, textFontField;
  private JLabel curveColorLabel, curveAngleLabel,
                 curvePositionLabel, curvePointsLabel;
  private JTextField curveColorField, curveAngleField,
                     curvePositionField;
  private JTextArea curvePointsArea;
  private JScrollPane curvePointsScrollPane;

}

