import java.awt.*;
import javax.swing.*;
import java.net.*;

public class Display4Images extends JApplet
{
  public void init()
  {
    Image image = null;

    String imageURL = getParameter("imageURL");
    if (imageURL == null)
    {
      imageURL = "Images/wrox_logo.gif";
    }

    try
    {
      // Image from a file specified by a URL
      image = getImage(new URL(getCodeBase(),imageURL)); 
    }
    catch(MalformedURLException e)
    {
      System.out.println("Failed to create URL:\n" + e);
      return;
    }

    imagePanel = new ImagePanel(image);  // Create panel showing the image

    int imageWidth = image.getWidth(this);                     // Get its width
    int imageHeight = image.getHeight(this);                   // and its height
    if(imageWidth != -1 && imageHeight != -1) {                // If they are available
      resize(imageWidth*2,imageHeight*2);                      // set applet size to fit
      imagePanel.setImageSize(imageWidth,imageHeight);         // and tell the ImagePanel
                                                               // how big it is
    }

    getContentPane().add(imagePanel);           // Add the panel to the content pane
  }

  public boolean imageUpdate(Image img,         // Reference to the image
                             int flags,         // Flags identifying what is available
                             int x,             // x coordinate
                             int y,             // y coordinate
                             int width,         // Image width
                             int height)        // Image height
  {
    if((flags & WIDTH) > 0 && (flags & HEIGHT) > 0)
    {
      resize(width*2,height*2);                 // Set applet size to fit the image
      imagePanel.setImageSize(width,height);    // and tell panel how bit it is
      repaint();                                // Repaint the applet in its new size
      return false; 
    }
    else
      return true;                              // More info required
  }

  ImagePanel imagePanel;                        // The panel where we are painting the images


  // Class representing a panel displaying an image
  class ImagePanel extends JPanel
  {
    public ImagePanel(Image image)
    {
     this.image = image;
    }

    public void setImageSize(int width, int height)
    {
      this.width = width;                       // Remember the image's width
      this.height = height;                     // ... and its height
    }

    public void paint(Graphics g)
    {
      g.drawImage(image, 0, 0, this);           // Display the image
      g.drawImage(image, width, 0, this);       // ... and again
      g.drawImage(image, 0, height, this);      // ... and again
      g.drawImage(image, width, height, this);  // ... and again!
    }

    Image image;                                // The image
    int width;                                  // its width
    int height;                                 // its height
  }
}
