// Defines application wide constants

import java.awt.*;
import java.io.File;

public interface Constants
{ 
  // Element type definitions
  int LINE      = 101;
  int RECTANGLE = 102;
  int CIRCLE    = 103;
  int CURVE     = 104;
  int TEXT      = 105;

  // Operating modes
  int NORMAL = 0;
  int MOVE   = 1;
  int ROTATE = 2;

  // Line types
  int SOLID_LINE = 201;
  int DASHED_LINE = 202;
  int DOTTED_LINE = 203;

  // Line widths
  int THIN_LINE = 301;
  int MEDIUM_LINE = 302;
  int THICK_LINE = 303;

  // Initial conditions
  int DEFAULT_ELEMENT_TYPE = LINE;
  Color DEFAULT_ELEMENT_COLOR = Color.blue;
  int DEFAULT_LINE_TYPE = SOLID_LINE;
  int DEFAULT_LINE_WIDTH = THIN_LINE;
  Font DEFAULT_FONT = new Font("Times New Roman",Font.PLAIN, 12);
  File DEFAULT_DIRECTORY = new File("C:/Sketches");
  String DEFAULT_FILENAME = "Sketch.ske";

}

