import java.awt.*;
import javax.swing.*;
import java.net.*;
import java.util.*;
import java.io.*;

public class Slideshow extends JApplet
{
  public void init()
  {
    URL imageURL;
    URLConnection connection;
    Image nextImage;

    String imageCountString = getParameter("imagecount");
    if(imageCountString != null)
      imageCount = Integer.parseInt(imageCountString);

    images = new Image[imageCount];

    String intervalString = getParameter("interval");
    if(intervalString != null)
      interval = Integer.parseInt(intervalString);

    try
    {
      for (int i=0; i<imageCount; i++)
      {
        imageURL = new URL(getCodeBase(),"Images/image" + i + ".gif");

        images[i] = getImage(imageURL);
      }
    }
    catch(MalformedURLException e)
    {
      System.out.println("Failed to create URL:\n" + e);
      return;
    }

    imagePanel = new ImagePanel();  // Create panel showing the images

    getContentPane().add(imagePanel);           // Add the panel to the content pane
  }

  public void start()
  {
    imagePanel.startAnimating();
  }

  public void stop()
  {
    imagePanel.stopAnimating();
  }


  ImagePanel imagePanel;                        // The panel where we are painting the images
  java.util.Timer timer = new java.util.Timer();
  Image[] images;                          // The images
  int imageCount = 0;
  int interval = 1000;


  // Class representing a panel displaying an image
  class ImagePanel extends JPanel
  {
    public void startAnimating()
    {
      // Use fixed-delay execution to get smooth animation
      timer.schedule(new java.util.TimerTask()
        {
          public void run()
          {
            // Paint next image
            imagePanel.repaint();

            // Update to do next image
            currentImage = (currentImage+1)%imageCount;
          }
        },
        0,                                    // ...starting now
        interval);                            // Repaint interval
    }

    public void stopAnimating()
    {
      timer.cancel();                        // Stop the timer
    }

    public void paint(Graphics g)
    {
       Graphics2D g2D = (Graphics2D)g;
       Dimension size = getSize();

       g2D.setPaint(Color.lightGray);                          // Set a background color
       g2D.fillRect(0, 0, size.width, size.height);            // paint background

       currentImageWidth = (images[currentImage]).getWidth(this);
       currentImageHeight = (images[currentImage]).getHeight(this);

       if ((currentImageWidth == -1) || (currentImageHeight == -1))
         return;

       g2D.drawImage(images[currentImage],
                     (size.width-currentImageWidth)/2,
                     (size.height-currentImageHeight)/2,
                     currentImageWidth, currentImageHeight, this);
    }

    int currentImage = 0;
    int currentImageWidth, currentImageHeight;
  }
}
