// Sketching application
import java.awt.*;
import java.awt.event.*;

public class Sketcher
{
  public static void main(String[] args)
  {
    theApp = new Sketcher();              // Create the application object
    theApp.init();                        // ...and initialize it
  }

  // Initialization of the application
  public void init()
  {
    window = new SketchFrame("Sketcher");
    Toolkit theKit = window.getToolkit();           // Get the window toolkit
    Dimension wndSize = theKit.getScreenSize();     // Get screen size

    // Set the position to screen center & size to 2/3 screen size
    window.setBounds(wndSize.width/6, wndSize.height/6,        // Position
                     2*wndSize.width/3, 2*wndSize.height/3);   // Size 

    window.addWindowListener(new WindowHandler());  // Add window listener
    window.setVisible(true);                        // Display the window
  }

  // Handler class for window events
  class WindowHandler extends WindowAdapter
  {
    // Handler for window closing event
    public void windowClosing(WindowEvent e)
    {
      window.dispose();                           // Release the window resources
      System.exit(0);                             // End the application
    }
  }

  private static SketchFrame window;              // The application window
  private static Sketcher theApp;                 // The application object
}

