import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class Sketcher
{
  public static void main(String[] args)
  {
    theApp = new Sketcher();                       // Create the application object
    theApp.init();                                 // ... and initialize it
  }

  public void init()
  {
    window = new SketchFrame("Sketcher", this);    // Create the app window
    Toolkit theKit = window.getToolkit();          // Get the window toolkit
    Dimension wndSize = theKit.getScreenSize();    // Get screen size

    // Set the position to screen center & size to 2/3 screen size
    window.setBounds(wndSize.width/6, wndSize.height/6,        // Position
                     2*wndSize.width/3, 2*wndSize.height/3);   // Size 

    window.addWindowListener(new WindowHandler()); // Add window listener

    sketch = new SketchModel();                 // Create the model
    view = new SketchView(this);                // Create the view
    sketch.addObserver((Observer)view);         // Register the view with the model
    sketch.addObserver((Observer)window);      // Register window as observer
    window.getContentPane().add(view, BorderLayout.CENTER);
    window.setVisible(true);
  }

  // Return a reference to the application window
  public SketchFrame getWindow()
  { 
     return window; 
  }

  // Return a reference to the model
  public SketchModel getModel()
  { 
     return sketch; 
  }

  // Return a reference to the view
  public SketchView getView()
  { 
     return view; 
  }

  // Handler class for window events
  class WindowHandler extends WindowAdapter
  {
    // Handler for window closing event
    public void windowClosing(WindowEvent e)
    {
      // Code to be added here later...
    }
  }

  public void insertModel(SketchModel newSketch)
  {
    sketch = newSketch;                           // Store the new sketch
    sketch.addObserver((Observer)view);           // Add the view as observer
    sketch.addObserver((Observer)window);         // Add the app window as observer
    view.repaint();                               // Repaint the view
  }

  private SketchModel sketch;                     // The data model for the sketch
  private SketchView view;                        // The view of the sketch
  private static SketchFrame window;              // The application window
  private static Sketcher theApp;                 // The application object
}

