import javax.sound.sampled.*;
public class PlumbSoundSystem
{
  public static void main(String args[])
  {
    Mixer.Info[] mixers = AudioSystem.getMixerInfo();  // Info on all mixers
    Mixer mixer = null;
    Line.Info[] lines = null;
    AudioFormat[] formats = null;

    for(int i=0 ; i<mixers.length ; i++)               // For each mixer...
    {                                                  // show the details...
      System.out.println("\nMixer " + (i+1) + ":");
      System.out.println("\tName: "+mixers[i].getName()+
                         " Vendor: "+mixers[i].getVendor()+
                         " Version: " + mixers[i].getVersion() +
                         "\n\t\tDescription: " + mixers[i].getDescription());


      mixer = AudioSystem.getMixer(mixers[i]);          // Get the mixer...
      lines = mixer.getSourceLineInfo();                // ...and its source lines info
      for(int j=0 ; j<lines.length ; j++)               // For each source line...
      {                                                 // show the details...
        System.out.println("\tSource Line " + (j+1) + ":" + lines[j]);

        formats = ((DataLine.Info)lines[j]).getFormats();
        for(int k = 0 ; k<formats.length ; k++)     // Show details of the formats
          System.out.println("\t\t" + formats[k]);  // supported
      }
        
       lines = mixer.getTargetLineInfo();               // Now get the lowdown
      for(int j=0 ; j<lines.length ; j++)               // on the target lines 
      {
        System.out.println("\tTarget Line " + (j+1) + ":" + lines[j]);
        formats = ((DataLine.Info)lines[j]).getFormats();
        for(int k = 0 ; k<formats.length ; k++)
          System.out.println("\t\t" + formats[k]);
      }
    }    
  }
}
