import java.sql.*;

public class Metadata
{
  public static void main(String[] args)
  {
    // Load the driver
    try
    {
      // Load the driver class
      Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");

      // Define the data source for the driver
      String sourceURL = "jdbc:odbc:technical_library";

      // Create a connection through the DriverManager 
      Connection databaseConnection = DriverManager.getConnection(sourceURL);

      Statement statement = databaseConnection.createStatement();

      ResultSet authorNames = statement.executeQuery("SELECT * FROM authors");

      /* Output the resultset data
      while(authorNames.next())
      System.out.println(authorNames.getString("lastname")+" "+
                                               authorNames.getString("firstname"));*/

      ResultSetMetaData metadata = authorNames.getMetaData();
      int columns = metadata.getColumnCount();                 // Get number of columns

      for(int i = 1 ; i<= columns ; i++)                       // For each column
        if(metadata.getColumnType(i) == Types.CHAR)            // if it is CHAR
          System.out.println(metadata.getColumnName(i));      // display the name

      int row = 0;                                            // Row number
      while(authorNames.next())                                   // For each row
      {
        System.out.print("\nRow "+(++row)+":");               // increment row count
        for(int i = 1 ; i<= columns ; i++)                    // For each column
          if(metadata.getColumnType(i) == Types.CHAR)         // if it is CHAR display it
            System.out.print(" "+authorNames.getString(i));
      }
    }
    catch(ClassNotFoundException cnfe)
    {
      System.err.println(cnfe);
    }
    catch(SQLException sqle)
    {
      System.err.println(sqle);
    }
  }
}