import javax.swing.event.*;

class DatabaseBrowse2 extends JFrame implements ActionListener, TreeSelectionListener


dbTree.addTreeSelectionListener(this);

  public void valueChanged(TreeSelectionEvent e)
  {
    TreePath[] paths = dbTree.getSelectionPaths();
    if(paths == null)
      return;

    boolean tableSelected = false;             // Set true if a table is selected
    String column;                             // Stores a column name from a path
    String table;                              // Stores a table name from a path
    String columnsParam = null;                // Column names in SQL SELECT
    String tableParam = null;                  // Table name in SQL SELECT
    String message = null;                     // Message for status area
    for(int  j = 0; j < paths.length ; j++)
    {
      switch(paths[j].getPathCount())
      {
        case 2:                                // We have a table selected
          tableParam = (String)
                          (((DefaultMutableTreeNode)
                                  (paths[j].getPathComponent(1))).getUserObject());
          columnsParam = "*";               // Select all columns
          tableSelected = true;             // Set flag for a table selected
          message = "Complete " + tableParam + " table displayed";
          break;

        case 3:                               // Column selected
          table = (String)
                      (((DefaultMutableTreeNode)
                                  (paths[j].getPathComponent(1))).getUserObject());
          if(tableParam == null)
            tableParam = table;

          else if(tableParam != table)
            break;
          column = (String)
                       (((DefaultMutableTreeNode)
                                  (paths[j].getPathComponent(2))).getUserObject());
          if(columnsParam == null)           // If no previous columns
            columnsParam = column;           // add the column
          else                               // otherwise
            columnsParam += "," + column;    // we need a comma too
          message = columnsParam + " displayed from " + tableParam + " table.";
          break;
      }
      if(tableSelected)                      // If a table was selected
        break;                               // we are done
    }
    try
    {
      // Display the columns and change the scroll pane border
      tableModel.setResultSet(statement.executeQuery("SELECT " + columnsParam+" FROM " + tableParam));
      tablePane.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.darkGray),
                         tableParam, TitledBorder.CENTER, TitledBorder.DEFAULT_POSITION));
    }
    catch(SQLException sqle)
    {
      message = "Selection event Error\n" + sqle.getMessage();
      System.err.println(message);
    }
    if(message != null)
    status.setText(message);
  }

